import oscP5.*;
import netP5.*;
import themidibus.*;
MidiBus myBus;

OscP5 oscP5;
NetAddress myRemoteLocation;
float GyroX, GyroY, GyroZ;
float OrientationM11, OrientationM12, OrientationM13, OrientationM21, OrientationM22, OrientationM23, OrientationM31, OrientationM32, OrientationM33;
float AccelX, AccelY, AccelZ;
float MagnX, MagnY, MagnZ;
float ValueGyroX, ValueGyroY, ValueGyroZ;
boolean AccelXState = false;
boolean lastAccelXState = false;
boolean AccelYState = false;
boolean lastAccelYState = false;

void setup() {

  size(800, 400);
  MidiBus.list(); // Liste aller Geräte ausgeben
  myBus = new MidiBus(this, -1, "Bus 1");
  
  oscP5 = new OscP5(this, 8001);
  myRemoteLocation = new NetAddress("127.0.0.1", 8100);
  oscP5.plug(this, "Gyro", "/gyrosc/gyro");
  oscP5.plug(this, "OrientationMatrix", "/gyrosc/rmatrix");
  oscP5.plug(this, "Accelerometer", "/gyrosc/accel");
  oscP5.plug(this, "Magnetometer", "/gyrosc/mag");
}

public void Gyro(float X, float Y, float Z) {
  //println("### plug event method. received a message /test.");
  //println(" 3 floats received: "+X+", "+Y+", "+Z);
  GyroX = X;
  GyroY = Y;
  GyroZ = Z;
}

public void OrientationMatrix(float m11, float m12, float m13, float m21, float m22, float m23, float m31, float m32, float m33) {
  //println("### plug event method. received a message /test.");
  //println(" 3 floats received: "+m11+", "+m12+", "+m13+", "+m21+", "+m22+", "+m23+", "+m31+", "+m32+", "+m33);
  OrientationM11 = m11;
  OrientationM12 = m12;
  OrientationM13 = m13;
  OrientationM21 = m21;
  OrientationM22 = m22;
  OrientationM23 = m23;
  OrientationM31 = m31;
  OrientationM32 = m32;
  OrientationM33 = m33;
}

public void Accelerometer(float X, float Y, float Z) {
  //println("### plug event method. received a message /test.");
  //println(" 3 floats received: "+X+", "+Y+", "+Z);
  AccelX = X;
  AccelY = Y;
  AccelZ = Z;
}

public void Magnetometer(float X, float Y, float Z) {
  //println("### plug event method. received a message /test.");
  //println(" 3 floats received: "+X+", "+Y+", "+Z);
  MagnX = X;
  MagnY = Y;
  MagnZ = Z;
}

void draw() {
  background(0);
  fill(255);
  frameRate(5);
  
  // sends the message to control the synth
      //sendMessageGyroX();
      sendMessageGyroY();
      sendMessageGyroZ();
      //sendMessageM11();
      //sendMessageM12();
      //sendMessageM13();
      //sendMessageM21();
      //sendMessageM22();
      //sendMessageM23();
      //sendMessageM31();
      //sendMessageM32();
      //sendMessageM33();
      //sendMessageAccelX();
      //sendMessageAccelY();
      //sendMessageAccelZ();
      //sendMessageMagnX();
      //sendMessageMagnY();
      //sendMessageMagnZ();*/
  println(GyroY);
  
  
  if(AccelX > 0.3 || AccelX < -0.3){
    //myBus.sendNoteOn(2, 64, 127);
    AccelXState = true;
    
   //println("NoteOn");
  }
  else{
    //myBus.sendNoteOff(2, 64, 127);
    AccelXState = false;
  }
  if(AccelXState != lastAccelXState){
    if(AccelXState == true){
      myBus.sendNoteOn(2, 64, 127);
      println("NoteOn");
    }
    else{
      myBus.sendNoteOff(2, 64, 127);
      println("NoteOff");
    }
  }
  lastAccelXState = AccelXState;
  
}
